// Auto-generated template file: command_ALARM_FIRED_GET.tpl.c
// Generation timestamp: 2021-06-17 18:31:59.933877


#include "../typedefs.h"  
#include "../communication.h"  
#include "../hardware.h"
#include "../spurious.h" // NOT INCLUDED IN GENERATED CODE

err_t command_ALARM_FIRED_GET(void) {
    // Command: ALARM_FIRED_GET
    // Description: Get the has-fired flag of one alarm (or all alarms OR-ed)
    // 
    // Request code: CMDCODE_ALARM_FIRED_GET_REQ
    // Response code: CMDCODE_ALARM_FIRED_GET_REQ
    // Request payload (length in bytes is 1):
    //     field #0   (1 byte) [type: enum_alarm_number_ext_t] : ALARM_NUMBER_EXT (Alarm number)
    // Response payload (length in bytes is 2):
    //     field #0   (1 byte) [type: enum_alarm_number_ext_t] : ALARM_NUMBER_EXT (Alarm number)
    //     field #1   (1 byte) [type: enum_firedstate_t] : FIREDSTATE (Fired state)

    // Auto-generated section: request payload fields reading
    enum_alarm_number_ext_t req_alarm_number_ext = (enum_alarm_number_ext_t)communication_request_payload_retrieve_uint8_t();
    // checking range for enum field req_alarm_number_ext
    if((uint8_t)req_alarm_number_ext < (uint8_t)enum_alarm_number_ext_t_min) return ERR_RANGE;
    if((uint8_t)req_alarm_number_ext > (uint8_t)enum_alarm_number_ext_t_max) return ERR_RANGE;
    // End of auto-generated section

    // USER CODE HERE
    // TODO CHECK command_ALARM_FIRED_GET    
    enum_alarm_number_ext_t resp_alarm_number_ext = req_alarm_number_ext;
    enum_firedstate_t resp_firedstate = FIREDSTATE_NO;     
    if(req_alarm_number_ext == ALARM_NUMBER_EXT_ALARMS_ALL_ORED) {
        for(uint8_t enum_idx = enum_alarm_number_t_min; enum_idx <= enum_alarm_number_t_max; enum_idx++) {
            alarm_firecount_t* p_firecount = alarm_get_firecount_ptr_by_enum((enum_alarm_number_t)enum_idx);
            INTERRUPT_GlobalInterruptDisable();
            if((*p_firecount) != 0) resp_firedstate = FIREDSTATE_YES;
            INTERRUPT_GlobalInterruptEnable();
        }
    }else{
        alarm_firecount_t* p_firecount = alarm_get_firecount_ptr_by_enum((enum_alarm_number_t)req_alarm_number_ext);
        INTERRUPT_GlobalInterruptDisable();
        if((*p_firecount) != 0) resp_firedstate = FIREDSTATE_YES;
        INTERRUPT_GlobalInterruptEnable();
    }

    // Auto-generated section: response payload fields writing
    communication_response_payload_appender_reset();
    communication_response_payload_append_uint8_t((uint8_t)resp_alarm_number_ext);
    communication_response_payload_append_uint8_t((uint8_t)resp_firedstate);
    return NOERR;
    // End of auto-generated section
}
