// Auto-generated template file: command_ALARM_MAXCOUNT_GETALL.tpl.c
// Generation timestamp: 2021-06-24 21:21:08.464784


#include "../typedefs.h"  
#include "../communication.h"  
#include "../hardware.h"
#include "../spurious.h" // NOT INCLUDED IN GENERATED CODE

err_t command_ALARM_MAXCOUNT_GETALL(void) {
    // Command: ALARM_MAXCOUNT_GETALL
    // Description: Get the current maxcount value of all alarms
    // 
    // Request code: CMDCODE_ALARM_MAXCOUNT_GETALL_REQ
    // Response code: CMDCODE_ALARM_MAXCOUNT_GETALL_REQ
    // Request payload (length in bytes is 0):
    // Response payload (length in bytes is 28):
    //     field #0   (2 bytes) [type: uint16_t  ] : MON_VEOC_RTN_I_ALARM_SLOW_MAXCOUNT (Alarm MON_VEOC_RTN_I_ALARM_SLOW maxcount value)
    //     field #1   (2 bytes) [type: uint16_t  ] : MON_VEOC_RTN_I_ALARM_FAST_MAXCOUNT (Alarm MON_VEOC_RTN_I_ALARM_FAST maxcount value)
    //     field #2   (2 bytes) [type: uint16_t  ] : MON_VEOC_FWR_I_ALARM_SLOW_MAXCOUNT (Alarm MON_VEOC_FWR_I_ALARM_SLOW maxcount value)
    //     field #3   (2 bytes) [type: uint16_t  ] : MON_VEOC_FWR_I_ALARM_FAST_MAXCOUNT (Alarm MON_VEOC_FWR_I_ALARM_FAST maxcount value)
    //     field #4   (2 bytes) [type: uint16_t  ] : MON_HYDRO_I_ALARM_SLOW_MAXCOUNT (Alarm MON_HYDRO_I_ALARM_SLOW maxcount value)
    //     field #5   (2 bytes) [type: uint16_t  ] : MON_HYDRO_I_ALARM_FAST_MAXCOUNT (Alarm MON_HYDRO_I_ALARM_FAST maxcount value)
    //     field #6   (2 bytes) [type: uint16_t  ] : MON_LBL_I_ALARM_SLOW_MAXCOUNT (Alarm MON_LBL_I_ALARM_SLOW maxcount value)
    //     field #7   (2 bytes) [type: uint16_t  ] : MON_LBL_I_ALARM_FAST_MAXCOUNT (Alarm MON_LBL_I_ALARM_FAST maxcount value)
    //     field #8   (2 bytes) [type: uint16_t  ] : FLAG_DUL_ALARMPOS1_ALARM_MAXCOUNT (Alarm FLAG_DUL_ALARMPOS1_ALARM maxcount value)
    //     field #9   (2 bytes) [type: uint16_t  ] : FLAG_DUL_ALARMPOS2_ALARM_MAXCOUNT (Alarm FLAG_DUL_ALARMPOS2_ALARM maxcount value)
    //     field #10  (2 bytes) [type: uint16_t  ] : FLAG_DUL_ALARMNEG1_ALARM_MAXCOUNT (Alarm FLAG_DUL_ALARMNEG1_ALARM maxcount value)
    //     field #11  (2 bytes) [type: uint16_t  ] : FLAG_DUL_ALARMNEG2_ALARM_MAXCOUNT (Alarm FLAG_DUL_ALARMNEG2_ALARM maxcount value)
    //     field #12  (2 bytes) [type: uint16_t  ] : FLAG_HYDRO_PWR_FAULT_ALARM_MAXCOUNT (Alarm FLAG_HYDRO_PWR_FAULT_ALARM maxcount value)
    //     field #13  (2 bytes) [type: uint16_t  ] : FLAG_LBL_PWR_FAULT_ALARM_MAXCOUNT (Alarm FLAG_LBL_PWR_FAULT_ALARM maxcount value)

    // Auto-generated section: request payload fields reading
    // End of auto-generated section

    // USER CODE HERE
    // TODO CHECK command_ALARM_MAXCOUNT_GETALL
    
    // IMPORTANT: we are assuming (please double check) that the 
    // enum_alarm_number_t is ordered as the payload  
    
    communication_response_payload_appender_reset();    
    for(enum_alarm_number_t alarm_number = enum_alarm_number_t_min; alarm_number <= enum_alarm_number_t_max; alarm_number++) {
        alarm_timeout_t* p_maxcount = alarm_get_timeout_counter_max_ptr_by_enum(alarm_number);
        INTERRUPT_GlobalInterruptDisable();
        alarm_timeout_t maxcount = (*p_maxcount);
        INTERRUPT_GlobalInterruptEnable();        
        communication_response_payload_append_uint16_t((uint16_t)maxcount);
    }
    
    // NOTICE: SOME GENERATED CODE REMOVED
    return NOERR;
    // End of auto-generated section
}