// Auto-generated template file: command_ALARM_THRESHOLD_SET.tpl.c
// Generation timestamp: 2021-06-17 18:31:59.933877


#include "../typedefs.h"  
#include "../communication.h"  
#include "../hardware.h"
#include "../spurious.h" // NOT INCLUDED IN GENERATED CODE

err_t command_ALARM_THRESHOLD_SET(void) {
    // Command: ALARM_THRESHOLD_SET
    // Description: Set the threshold value of one analog alarm
    // 
    // Request code: CMDCODE_ALARM_THRESHOLD_SET_REQ
    // Response code: CMDCODE_ALARM_THRESHOLD_SET_REQ
    // Request payload (length in bytes is 3):
    //     field #0   (1 byte) [type: enum_alarm_number_analog_t] : ALARM_NUMBER_ANALOG (Alarm number)
    //     field #1   (2 bytes) [type: uint16_t  ] : THRESHOLD  (Threshold value)
    // Response payload (length in bytes is 0):

    // Auto-generated section: request payload fields reading
    enum_alarm_number_analog_t req_alarm_number_analog = (enum_alarm_number_analog_t)communication_request_payload_retrieve_uint8_t();
    uint16_t req_threshold = (uint16_t)communication_request_payload_retrieve_uint16_t();
    // checking range for enum field req_alarm_number_analog
    if((uint8_t)req_alarm_number_analog < (uint8_t)enum_alarm_number_analog_t_min) return ERR_RANGE;
    if((uint8_t)req_alarm_number_analog > (uint8_t)enum_alarm_number_analog_t_max) return ERR_RANGE;
    // End of auto-generated section

    // USER CODE HERE
    // TODO CHECK command_ALARM_THRESHOLD_SET
    
    // retrieve the pointer to the requested alarm
    analogalarm_info_t* p_alarm = alarm_get_analog_alarm_ptr_by_enum((enum_alarm_number_t)req_alarm_number_analog);
    
    INTERRUPT_GlobalInterruptDisable();
    p_alarm->threshold = req_threshold;
    INTERRUPT_GlobalInterruptEnable();

    // Auto-generated section: response payload fields writing
    communication_response_payload_appender_reset();
    return NOERR;
    // End of auto-generated section
}
