// Auto-generated template file: command_SENSOR_AVERAGE_GETALL.tpl.c
// Generation timestamp: 2021-06-17 18:31:59.933877


#include "../typedefs.h"  
#include "../communication.h"  
#include "../hardware.h"
#include "../spurious.h" // NOT INCLUDED IN GENERATED CODE
#include "../adcreader.h" // NOT INCLUDED IN GENERATED CODE

err_t command_SENSOR_AVERAGE_GETALL(void) {
    // Command: SENSOR_AVERAGE_GETALL
    // Description: Get all sensors' mean values
    // 
    // Request code: CMDCODE_SENSOR_AVERAGE_GETALL_REQ
    // Response code: CMDCODE_SENSOR_AVERAGE_GETALL_REQ
    // Request payload (length in bytes is 0):
    // Response payload (length in bytes is 22):
    //     field #0   (2 bytes) [type: uint16_t  ] : MON_DUL_BOARDTEMP_MEAN (Variable MON_DUL_BOARDTEMP mean)
    //     field #1   (2 bytes) [type: uint16_t  ] : MON_TEMP2_MEAN (Variable MON_TEMP2 mean)
    //     field #2   (2 bytes) [type: uint16_t  ] : MON_TEMP1_MEAN (Variable MON_TEMP1 mean)
    //     field #3   (2 bytes) [type: uint16_t  ] : MON_VEOC_RTN_I_MEAN (Variable MON_VEOC_RTN_I mean)
    //     field #4   (2 bytes) [type: uint16_t  ] : MON_VEOC_FWR_I_MEAN (Variable MON_VEOC_FWR_I mean)
    //     field #5   (2 bytes) [type: uint16_t  ] : MON_HYDRO_I_MEAN (Variable MON_HYDRO_I mean)
    //     field #6   (2 bytes) [type: uint16_t  ] : MON_INPUT_V_MEAN (Variable MON_INPUT_V mean)
    //     field #7   (2 bytes) [type: uint16_t  ] : MON_LBL_I_MEAN (Variable MON_LBL_I mean)
    //     field #8   (2 bytes) [type: uint16_t  ] : MON_GLRA_I_MEAN (Variable MON_GLRA_I mean)
    //     field #9   (2 bytes) [type: uint16_t  ] : MON_GLRB_I_MEAN (Variable MON_GLRB_I mean)
    //     field #10  (2 bytes) [type: uint16_t  ] : MON_PWB_I_MEAN (Variable MON_PWB_I mean)

    // Auto-generated section: request payload fields reading
    // End of auto-generated section

    // USER CODE HERE
    // TODO CHECK command_SENSOR_AVERAGE_GETALL
    // IMPORTANT: we are assuming that analog enum_variable_number_t indexes are ordered as in the response payload   
    //            we are also assuming to correctly know the number of analog and digital variables
    // TODO: FIX ME (involves python too)
    uint16_t analog_value_mean[11];
    uint8_t analog_variable_index = 0;
    
     
    for(uint8_t variable_index = enum_variable_number_t_min; variable_index <= enum_variable_number_t_max; variable_index++) {
        if(variable_is_analog_by_enum(variable_index)) {
            analog_variable_t* p_variable = analog_variable_get_pointer_by_enum(variable_index);
            INTERRUPT_GlobalInterruptDisable();     
            // the mean value is obtained as a sum, properly shifted to the right factor            
            analog_value_mean[analog_variable_index] = (uint16_t)((p_variable->sum_last >> adcreader_averaging_prescaler) & 0x0000ffff);       
            INTERRUPT_GlobalInterruptEnable();
            analog_variable_index++;
        }
    }
    
    // analog variables means
    for(uint8_t analog_variable_index_tmp = 0; analog_variable_index_tmp < analog_variable_index; analog_variable_index_tmp++) {
        communication_response_payload_append_uint16_t((uint16_t)analog_value_mean[analog_variable_index_tmp]);
    }
    
    // NOTICE: SOME GENERATED CODE REMOVED
    return NOERR;
    // End of auto-generated section
}
