// Auto-generated template file: command_SENSOR_GET_SINGLE.tpl.c
// Generation timestamp: 2021-06-17 18:31:59.933877


#include "../typedefs.h"  
#include "../communication.h"  
#include "../hardware.h"
#include "../spurious.h" // NOT INCLUDED IN GENERATED CODE
#include "../adcreader.h" // NOT INCLUDED IN GENERATED CODE

err_t command_SENSOR_GET_SINGLE(void) {
    // Command: SENSOR_GET_SINGLE
    // Description: Get one sensor's current value, offset value, max value, and mean value
    // 
    // Request code: CMDCODE_SENSOR_GET_SINGLE_REQ
    // Response code: CMDCODE_SENSOR_GET_SINGLE_REQ
    // Request payload (length in bytes is 1):
    //     field #0   (1 byte) [type: enum_variable_number_t] : VARIABLE_NUMBER (Variable number)
    // Response payload (length in bytes is 9):
    //     field #0   (1 byte) [type: enum_variable_number_t] : VARIABLE_NUMBER (Variable number)
    //     field #1   (2 bytes) [type: uint16_t  ] : VALUE      (Last acquired sensor value (0/1 for digital sensors))
    //     field #2   (2 bytes) [type: uint16_t  ] : OFFSET     (Sensor offset value (acquired at start-up, reports zero for digital sensors))
    //     field #3   (2 bytes) [type: uint16_t  ] : MAXVALUE   (Sensor maximum value since last reset (0/1 for digital sensors))
    //     field #4   (2 bytes) [type: uint16_t  ] : MEANVALUE  (Sensor mean value (0 for digital sensors))

    // Auto-generated section: request payload fields reading
    enum_variable_number_t req_variable_number = (enum_variable_number_t)communication_request_payload_retrieve_uint8_t();
    // checking range for enum field req_variable_number
    if((uint8_t)req_variable_number < (uint8_t)enum_variable_number_t_min) return ERR_RANGE;
    if((uint8_t)req_variable_number > (uint8_t)enum_variable_number_t_max) return ERR_RANGE;
    // End of auto-generated section

    // USER CODE HERE
    // TODO CHECK command_SENSOR_GET_SINGLE
    enum_variable_number_t resp_variable_number = req_variable_number;
    uint16_t resp_value;
    uint16_t resp_offset;
    uint16_t resp_maxvalue;
    uint16_t resp_meanvalue;    
    if(variable_is_analog_by_enum(req_variable_number)) {
        analog_variable_t* p_variable = analog_variable_get_pointer_by_enum(req_variable_number);
        INTERRUPT_GlobalInterruptDisable();
        resp_value = p_variable->value;
        resp_offset = p_variable->offset;
        resp_maxvalue = p_variable->value_max;
        // the mean value is obtained as a sum, properly shifted to the right factor
        resp_meanvalue = (uint16_t)((p_variable->sum_last >> adcreader_averaging_prescaler) & 0x0000ffff);
        INTERRUPT_GlobalInterruptEnable();
        
    }else{
        digital_variable_t* p_variable = digital_variable_get_pointer_by_enum(req_variable_number);  
        INTERRUPT_GlobalInterruptDisable();
        resp_value = p_variable->value;
        resp_offset = 0;
        resp_maxvalue = p_variable->value_max;
        resp_meanvalue = 0;
        INTERRUPT_GlobalInterruptEnable(); 
    }

    // Auto-generated section: response payload fields writing
    communication_response_payload_appender_reset();
    communication_response_payload_append_uint8_t((uint8_t)resp_variable_number);
    communication_response_payload_append_uint16_t((uint16_t)resp_value);
    communication_response_payload_append_uint16_t((uint16_t)resp_offset);
    communication_response_payload_append_uint16_t((uint16_t)resp_maxvalue);
    communication_response_payload_append_uint16_t((uint16_t)resp_meanvalue);
    return NOERR;
    // End of auto-generated section
}
