// Auto-generated template file: command_SENSOR_VALUES_GETALL.tpl.c
// Generation timestamp: 2021-06-17 18:31:59.933877


#include "../typedefs.h"  
#include "../communication.h"  
#include "../hardware.h"
#include "../spurious.h" // NOT INCLUDED IN GENERATED CODE
#include "../adcreader.h" // NOT INCLUDED IN GENERATED CODE

err_t command_SENSOR_VALUES_GETALL(void) {
    // Command: SENSOR_VALUES_GETALL
    // Description: Get all sensors' values
    // 
    // Request code: CMDCODE_SENSOR_VALUES_GETALL_REQ
    // Response code: CMDCODE_SENSOR_VALUES_GETALL_REQ
    // Request payload (length in bytes is 0):
    // Response payload (length in bytes is 34):
    //     field #0   (2 bytes) [type: uint16_t  ] : MON_DUL_BOARDTEMP_VALUE (Variable MON_DUL_BOARDTEMP last acquired value)
    //     field #1   (2 bytes) [type: uint16_t  ] : MON_TEMP2_VALUE (Variable MON_TEMP2 last acquired value)
    //     field #2   (2 bytes) [type: uint16_t  ] : MON_TEMP1_VALUE (Variable MON_TEMP1 last acquired value)
    //     field #3   (2 bytes) [type: uint16_t  ] : MON_VEOC_RTN_I_VALUE (Variable MON_VEOC_RTN_I last acquired value)
    //     field #4   (2 bytes) [type: uint16_t  ] : MON_VEOC_FWR_I_VALUE (Variable MON_VEOC_FWR_I last acquired value)
    //     field #5   (2 bytes) [type: uint16_t  ] : MON_HYDRO_I_VALUE (Variable MON_HYDRO_I last acquired value)
    //     field #6   (2 bytes) [type: uint16_t  ] : MON_INPUT_V_VALUE (Variable MON_INPUT_V last acquired value)
    //     field #7   (2 bytes) [type: uint16_t  ] : MON_LBL_I_VALUE (Variable MON_LBL_I last acquired value)
    //     field #8   (2 bytes) [type: uint16_t  ] : MON_GLRA_I_VALUE (Variable MON_GLRA_I last acquired value)
    //     field #9   (2 bytes) [type: uint16_t  ] : MON_GLRB_I_VALUE (Variable MON_GLRB_I last acquired value)
    //     field #10  (2 bytes) [type: uint16_t  ] : MON_PWB_I_VALUE (Variable MON_PWB_I last acquired value)
    //     field #11  (1 byte) [type: enum_flag_dul_alarmpos1_state_t] : FLAG_DUL_ALARMPOS1_STATE (FLAG_DUL_ALARMPOS1 status)
    //     field #12  (1 byte) [type: enum_flag_dul_alarmpos2_state_t] : FLAG_DUL_ALARMPOS2_STATE (FLAG_DUL_ALARMPOS2 status)
    //     field #13  (1 byte) [type: enum_flag_dul_alarmneg1_state_t] : FLAG_DUL_ALARMNEG1_STATE (FLAG_DUL_ALARMNEG1 status)
    //     field #14  (1 byte) [type: enum_flag_dul_alarmneg2_state_t] : FLAG_DUL_ALARMNEG2_STATE (FLAG_DUL_ALARMNEG2 status)
    //     field #15  (1 byte) [type: enum_flag_hydro_pwr_fault_state_t] : FLAG_HYDRO_PWR_FAULT_STATE (FLAG_HYDRO_PWR_FAULT status)
    //     field #16  (1 byte) [type: enum_flag_lbl_pwr_fault_state_t] : FLAG_LBL_PWR_FAULT_STATE (FLAG_LBL_PWR_FAULT status)
    //     field #17  (1 byte) [type: enum_flag_glra_fault_state_t] : FLAG_GLRA_FAULT_STATE (FLAG_GLRA_FAULT status)
    //     field #18  (1 byte) [type: enum_flag_glrb_fault_state_t] : FLAG_GLRB_FAULT_STATE (FLAG_GLRB_FAULT status)
    //     field #19  (1 byte) [type: enum_flag_powerboard_fault_state_t] : FLAG_POWERBOARD_FAULT_STATE (FLAG_POWERBOARD_FAULT status)
    //     field #20  (1 byte) [type: enum_flag_glra_good_state_t] : FLAG_GLRA_GOOD_STATE (FLAG_GLRA_GOOD status)
    //     field #21  (1 byte) [type: enum_flag_glrb_good_state_t] : FLAG_GLRB_GOOD_STATE (FLAG_GLRB_GOOD status)
    //     field #22  (1 byte) [type: enum_flag_powerboard_good_state_t] : FLAG_POWERBOARD_GOOD_STATE (FLAG_POWERBOARD_GOOD status)

    // Auto-generated section: request payload fields reading
    // End of auto-generated section

    // USER CODE HERE
    // TODO CHECK command_SENSOR_VALUES_GETALL
    
    // IMPORTANT: we are assuming that analog enum_variable_number_t indexes are ordered as in the response payload
    // TODO: FIX ME (involves python too)
    uint16_t analog_value_data[11];
    digital_value_t digital_value_data[12];
    uint8_t analog_variable_index = 0;
    uint8_t digital_variable_index = 0;
    
    for(uint8_t variable_index = enum_variable_number_t_min; variable_index <= enum_variable_number_t_max; variable_index++) {
        if(variable_is_analog_by_enum(variable_index)) {
            analog_variable_t* p_variable = analog_variable_get_pointer_by_enum(variable_index);
            INTERRUPT_GlobalInterruptDisable();
            analog_value_data[analog_variable_index] = p_variable->value;
            INTERRUPT_GlobalInterruptEnable();
            analog_variable_index++;
        }else{
            digital_variable_t* p_variable = digital_variable_get_pointer_by_enum(variable_index);
            INTERRUPT_GlobalInterruptDisable();
            digital_value_data[digital_variable_index] = p_variable->value;
            INTERRUPT_GlobalInterruptEnable();            
            digital_variable_index++;
        }
    }
    
    // send data out
    communication_response_payload_appender_reset();
    // analog variables
    for(uint8_t analog_variable_index_tmp = 0; analog_variable_index_tmp < analog_variable_index; analog_variable_index_tmp++) {
        communication_response_payload_append_uint16_t((uint16_t)analog_value_data[analog_variable_index_tmp]);
    }
    // digital variables
    for(uint8_t digital_variable_index_tmp = 0; digital_variable_index_tmp < digital_variable_index; digital_variable_index_tmp++) {
        communication_response_payload_append_uint8_t((uint8_t)digital_value_data[digital_variable_index_tmp]);
    }
    
    // NOTICE: SOME GENERATED CODE REMOVED
    return NOERR;
    // End of auto-generated section
}
